/* This file is is generated by a shell script.  DO NOT EDIT! */

/* emulate the original gld for the given pdp11
   Copyright (C) 1991-2020 Free Software Foundation, Inc.
   Written by Steve Chamberlain steve@cygnus.com

   This file is part of the GNU Binutils.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston,
   MA 02110-1301, USA.  */

#define TARGET_IS_pdp11

#include "sysdep.h"
#include "bfd.h"
#include "bfdlink.h"
#include "ctf-api.h"

#include "ld.h"
#include "ldmain.h"
#include "ldmisc.h"

#include "ldexp.h"
#include "ldlang.h"
#include "ldfile.h"
#include "ldemul.h"


/* --- \begin{pdp11.em} */
#include "getopt.h"

static void
gldpdp11_before_parse (void)
{
  ldfile_set_output_arch ("pdp11", bfd_arch_unknown);
  /* for PDP11 Unix compatibility, default to --omagic */
  config.magic_demand_paged = FALSE;
  config.text_read_only = FALSE;
}

/* PDP11 specific options.  */
#define OPTION_IMAGIC 301

static void
gldpdp11_add_options
  (int ns ATTRIBUTE_UNUSED,
   char **shortopts,
   int nl,
   struct option **longopts,
   int nrl ATTRIBUTE_UNUSED,
   struct option **really_longopts ATTRIBUTE_UNUSED)
{
  static const char xtra_short[] = "z";
  static const struct option xtra_long[] =
  {
    {"imagic", no_argument, NULL, OPTION_IMAGIC},
    {NULL, no_argument, NULL, 0}
  };

  *shortopts = (char *) xrealloc (*shortopts, ns + sizeof (xtra_short));
  memcpy (*shortopts + ns, &xtra_short, sizeof (xtra_short));
  *longopts
    = xrealloc (*longopts, nl * sizeof (struct option) + sizeof (xtra_long));
  memcpy (*longopts + nl, &xtra_long, sizeof (xtra_long));
}

static void
gldpdp11_list_options (FILE *file)
{
  fprintf (file, _("  -N, --omagic   Do not make text readonly, do not page align data (default)\n"));
  fprintf (file, _("  -n, --nmagic   Make text readonly, align data to next page\n"));
  fprintf (file, _("  -z, --imagic   Make text readonly, separate instruction and data spaces\n"));
  fprintf (file, _("  --no-omagic    Equivalent to --nmagic\n"));
}

static bfd_boolean
gldpdp11_handle_option (int optc)
{
  switch (optc)
    {
    default:
      return FALSE;

    case 'z':
    case OPTION_IMAGIC:
      link_info.separate_code = 1;
      /* The --imagic format causes the .text and .data sections to occupy the
	 same memory addresses in separate spaces, so don't check overlap. */
      command_line.check_section_addresses = 0;
      break;
    }

  return TRUE;
}

/* We need a special case to prepare an additional linker script for option
 * --imagic where the .data section starts at address 0 rather than directly
 * following the .text section or being aligned to the next page after the
 * .text section. */
static char *
gldpdp11_get_script (int *isfile)
{
  *isfile = 0;

  if (bfd_link_relocatable (&link_info) && config.build_constructors)
    return
"/* Script for -Ur */\n\
/* Copyright (C) 2014-2020 Free Software Foundation, Inc.\n\
   Copying and distribution of this script, with or without modification,\n\
   are permitted in any medium without royalty provided the copyright\n\
   notice and this notice are preserved.  */\n\
OUTPUT_FORMAT(\"a.out-pdp11\", \"a.out-pdp11\",\n\
	      \"a.out-pdp11\")\n\
OUTPUT_ARCH(pdp11)\n\
SECTIONS\n\
{\n\
  .text :\n\
  {\n\
    CREATE_OBJECT_SYMBOLS\n\
    *(.text)\n\
  }\n\
  .data :\n\
  {\n\
    *(.data)\n\
    CONSTRUCTORS\n\
  }\n\
  .bss :\n\
  {\n\
   ;\n\
   *(.bss)\n\
   *(COMMON)\n"
"   ;\n\
   ;\n\
  }\n\
}\n\n"
  ; else if (bfd_link_relocatable (&link_info)) return
"/* Script for -r */\n\
/* Copyright (C) 2014-2020 Free Software Foundation, Inc.\n\
   Copying and distribution of this script, with or without modification,\n\
   are permitted in any medium without royalty provided the copyright\n\
   notice and this notice are preserved.  */\n\
OUTPUT_FORMAT(\"a.out-pdp11\", \"a.out-pdp11\",\n\
	      \"a.out-pdp11\")\n\
OUTPUT_ARCH(pdp11)\n\
SECTIONS\n\
{\n\
  .text :\n\
  {\n\
    CREATE_OBJECT_SYMBOLS\n\
    *(.text)\n\
  }\n\
  .data :\n\
  {\n\
    *(.data)\n\
  }\n\
  .bss :\n\
  {\n\
   ;\n\
   *(.bss)\n\
   *(COMMON)\n\
   ;\n"
"   ;\n\
  }\n\
}\n\n"
  ; else if (link_info.separate_code) return
"/* Script for -n */\n\
/* Copyright (C) 2014-2020 Free Software Foundation, Inc.\n\
   Copying and distribution of this script, with or without modification,\n\
   are permitted in any medium without royalty provided the copyright\n\
   notice and this notice are preserved.  */\n\
OUTPUT_FORMAT(\"a.out-pdp11\", \"a.out-pdp11\",\n\
	      \"a.out-pdp11\")\n\
OUTPUT_ARCH(pdp11)\n\
PROVIDE (__stack = 0);\n\
SECTIONS\n\
{\n\
  . = 0;\n\
  .text :\n\
  {\n\
    CREATE_OBJECT_SYMBOLS\n\
    *(.text)\n\
    _etext = .;\n\
    __etext = .;\n\
  }\n\
  . = 0;\n\
  .data :\n\
  {\n\
    *(.data)\n\
    CONSTRUCTORS\n\
    _edata  =  .;\n"
"    __edata  =  .;\n\
  }\n\
  .bss :\n\
  {\n\
    __bss_start = .;\n\
   *(.bss)\n\
   *(COMMON)\n\
   . = ALIGN(2);\n\
   _end = . ;\n\
   __end = . ;\n\
  }\n\
}\n\n"
  ; else if (!config.text_read_only) return
"/* Script for -N */\n\
/* Copyright (C) 2014-2020 Free Software Foundation, Inc.\n\
   Copying and distribution of this script, with or without modification,\n\
   are permitted in any medium without royalty provided the copyright\n\
   notice and this notice are preserved.  */\n\
OUTPUT_FORMAT(\"a.out-pdp11\", \"a.out-pdp11\",\n\
	      \"a.out-pdp11\")\n\
OUTPUT_ARCH(pdp11)\n\
PROVIDE (__stack = 0);\n\
SECTIONS\n\
{\n\
  . = 0;\n\
  .text :\n\
  {\n\
    CREATE_OBJECT_SYMBOLS\n\
    *(.text)\n\
    _etext = .;\n\
    __etext = .;\n\
  }\n\
  . = .;\n\
  .data :\n\
  {\n\
    *(.data)\n\
    CONSTRUCTORS\n\
    _edata  =  .;\n"
"    __edata  =  .;\n\
  }\n\
  .bss :\n\
  {\n\
    __bss_start = .;\n\
   *(.bss)\n\
   *(COMMON)\n\
   . = ALIGN(2);\n\
   _end = . ;\n\
   __end = . ;\n\
  }\n\
}\n\n"
  ; else if (!config.magic_demand_paged) return
"/* Script for -n */\n\
/* Copyright (C) 2014-2020 Free Software Foundation, Inc.\n\
   Copying and distribution of this script, with or without modification,\n\
   are permitted in any medium without royalty provided the copyright\n\
   notice and this notice are preserved.  */\n\
OUTPUT_FORMAT(\"a.out-pdp11\", \"a.out-pdp11\",\n\
	      \"a.out-pdp11\")\n\
OUTPUT_ARCH(pdp11)\n\
PROVIDE (__stack = 0);\n\
SECTIONS\n\
{\n\
  . = 0;\n\
  .text :\n\
  {\n\
    CREATE_OBJECT_SYMBOLS\n\
    *(.text)\n\
    _etext = .;\n\
    __etext = .;\n\
  }\n\
  . = ALIGN(8192);\n\
  .data :\n\
  {\n\
    *(.data)\n\
    CONSTRUCTORS\n\
    _edata  =  .;\n"
"    __edata  =  .;\n\
  }\n\
  .bss :\n\
  {\n\
    __bss_start = .;\n\
   *(.bss)\n\
   *(COMMON)\n\
   . = ALIGN(2);\n\
   _end = . ;\n\
   __end = . ;\n\
  }\n\
}\n\n"
  ; else return
"/* Default linker script, for normal executables */\n\
/* Copyright (C) 2014-2020 Free Software Foundation, Inc.\n\
   Copying and distribution of this script, with or without modification,\n\
   are permitted in any medium without royalty provided the copyright\n\
   notice and this notice are preserved.  */\n\
OUTPUT_FORMAT(\"a.out-pdp11\", \"a.out-pdp11\",\n\
	      \"a.out-pdp11\")\n\
OUTPUT_ARCH(pdp11)\n\
PROVIDE (__stack = 0);\n\
SECTIONS\n\
{\n\
  . = 0;\n\
  .text :\n\
  {\n\
    CREATE_OBJECT_SYMBOLS\n\
    *(.text)\n\
    _etext = .;\n\
    __etext = .;\n\
  }\n\
  . = ALIGN(8192);\n\
  .data :\n\
  {\n\
    *(.data)\n\
    CONSTRUCTORS\n\
    _edata  =  .;\n"
"    __edata  =  .;\n\
  }\n\
  .bss :\n\
  {\n\
    __bss_start = .;\n\
   *(.bss)\n\
   *(COMMON)\n\
   . = ALIGN(2);\n\
   _end = . ;\n\
   __end = . ;\n\
  }\n\
}\n\n"
; }

/* --- \end{pdp11.em} */


struct ld_emulation_xfer_struct ld_pdp11_emulation =
{
  gldpdp11_before_parse,
  syslib_default,
  hll_default,
  after_parse_default,
  after_open_default,
  after_check_relocs_default,
  before_place_orphans_default,
  after_allocation_default,
  set_output_arch_default,
  ldemul_default_target,
  before_allocation_default,
  gldpdp11_get_script,
  "pdp11",
  "a.out-pdp11",
  finish_default,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  gldpdp11_add_options,
  gldpdp11_handle_option,
  NULL,
  gldpdp11_list_options,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL
};
