/* This file is is generated by a shell script.  DO NOT EDIT! */

/* emulate the original gld for the given z80
   Copyright (C) 1991-2020 Free Software Foundation, Inc.
   Written by Steve Chamberlain steve@cygnus.com

   This file is part of the GNU Binutils.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston,
   MA 02110-1301, USA.  */

#define TARGET_IS_z80

#include "sysdep.h"
#include "bfd.h"
#include "bfdlink.h"
#include "ctf-api.h"

#include "ld.h"
#include "ldmain.h"
#include "ldmisc.h"

#include "ldexp.h"
#include "ldlang.h"
#include "ldfile.h"
#include "ldemul.h"

static void
gldz80_after_open (void)
{
}
/* --- \begin{z80.em} */

/* Set the machine type of the output file based on types of inputs.  */
static void
z80_after_open (void)
{
  bfd *abfd;

  /* For now, make sure all object files are of the same architecture.
     We may try to merge object files with different architecture together.  */
  for (abfd = link_info.input_bfds; abfd != NULL; abfd = abfd->link.next)
    {
      const bfd_arch_info_type *info;
      info = bfd_arch_get_compatible (link_info.output_bfd, abfd, FALSE);
      if (info == NULL)
	einfo (_("%F%P: %pB: Instruction sets of object files incompatible\n"),
	       abfd);
      else
        bfd_set_arch_info (link_info.output_bfd, info);
    }

  /* Call the standard elf routine.  */
  gldz80_after_open ();
}

/* --- \end{z80.em} */

static void
gldz80_before_parse (void)
{
#ifndef TARGET_			/* I.e., if not generic.  */
  ldfile_set_output_arch ("z80", bfd_arch_unknown);
#endif /* not TARGET_ */
}


static char *
gldz80_get_script (int *isfile)
{
  *isfile = 1;

  if (bfd_link_relocatable (&link_info) && config.build_constructors)
    return "ldscripts/z80.xu";
  else if (bfd_link_relocatable (&link_info))
    return "ldscripts/z80.xr";
  else if (!config.text_read_only)
    return "ldscripts/z80.xbn";
  else if (!config.magic_demand_paged)
    return "ldscripts/z80.xn";
  else
    return "ldscripts/z80.x";
}

struct ld_emulation_xfer_struct ld_z80_emulation =
{
  gldz80_before_parse,
  syslib_default,
  hll_default,
  after_parse_default,
  z80_after_open,
  after_check_relocs_default,
  before_place_orphans_default,
  after_allocation_default,
  set_output_arch_default,
  ldemul_default_target,
  before_allocation_default,
  gldz80_get_script,
  "z80",
  "coff-z80",
  finish_default,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL
};
